*
*	b8toha.s: part of xd(heXadecimal Dump tool)
*	Copyright  1994,95  씎Y(oo), HGG00736@niftyserve.or.jp
*
.ifndef	MPU
MPU	.equ	68000
.endif

	.offset	4
cset	.ds.l	1
dst	.ds.l	1
src	.ds.l	1
rest	.ds.l	1

~cset	.reg	a0
~dst	.reg	a1
~src	.reg	a2
~tmp	.reg	d0
~ch	.reg	d1
~cnt	.reg	d2

	.text
	.even
.if	MPU>=68020
	.quad
.endif
*
* uchar* b8toha(uchar* cset, uchar* dst, ulong* src, int rest)
* in:	cset	convert char set
*	dst	output buffer
*	src	pointer to convert value
*	rest	rest of src byte count
* out:	pointer to end of string
*
_b8toha::
	movem.l	cset(sp),~cset/~dst/~src
	moveq.l	#16,~cnt
	cmp.l	rest(sp),~cnt
	bls.s	b8toha
	move.l	rest(sp),~cnt
b8toha:
	lsr.l	#3,~cnt
	beq	b8toha_sp
	subq.l	#1,~cnt
	moveq.l	#0,~tmp
b8toha_loop:
	move.b	(~src)+,~ch
	move.b	~ch,~tmp
	lsr.b	#4,~tmp
	move.b	(~cset,~tmp.w),(~dst)+
	moveq.l	#$0f,~tmp
	and.b	~ch,~tmp
	move.b	(~cset,~tmp.w),(~dst)+
	move.b	(~src)+,~ch
	move.b	~ch,~tmp
	lsr.b	#4,~tmp
	move.b	(~cset,~tmp.w),(~dst)+
	moveq.l	#$0f,~tmp
	and.b	~ch,~tmp
	move.b	(~cset,~tmp.w),(~dst)+
	move.b	(~src)+,~ch
	move.b	~ch,~tmp
	lsr.b	#4,~tmp
	move.b	(~cset,~tmp.w),(~dst)+
	moveq.l	#$0f,~tmp
	and.b	~ch,~tmp
	move.b	(~cset,~tmp.w),(~dst)+
	move.b	(~src)+,~ch
	move.b	~ch,~tmp
	lsr.b	#4,~tmp
	move.b	(~cset,~tmp.w),(~dst)+
	moveq.l	#$0f,~tmp
	and.b	~ch,~tmp
	move.b	(~cset,~tmp.w),(~dst)+
	move.b	(~src)+,~ch
	move.b	~ch,~tmp
	lsr.b	#4,~tmp
	move.b	(~cset,~tmp.w),(~dst)+
	moveq.l	#$0f,~tmp
	and.b	~ch,~tmp
	move.b	(~cset,~tmp.w),(~dst)+
	move.b	(~src)+,~ch
	move.b	~ch,~tmp
	lsr.b	#4,~tmp
	move.b	(~cset,~tmp.w),(~dst)+
	moveq.l	#$0f,~tmp
	and.b	~ch,~tmp
	move.b	(~cset,~tmp.w),(~dst)+
	move.b	(~src)+,~ch
	move.b	~ch,~tmp
	lsr.b	#4,~tmp
	move.b	(~cset,~tmp.w),(~dst)+
	moveq.l	#$0f,~tmp
	and.b	~ch,~tmp
	move.b	(~cset,~tmp.w),(~dst)+
	move.b	(~src)+,~ch
	move.b	~ch,~tmp
	lsr.b	#4,~tmp
	move.b	(~cset,~tmp.w),(~dst)+
	moveq.l	#$0f,~tmp
	and.b	~ch,~tmp
	move.b	(~cset,~tmp.w),(~dst)+
	moveq.l	#' ',~tmp
	moveq.l	#7,~ch
b8toha_in_loop:
	move.b	~tmp,(~dst)+
	dbra	~ch,b8toha_in_loop
	dbra	~cnt,b8toha_loop

b8toha_sp:
	moveq.l	#' ',~ch
	move.l	#16,~cnt
	sub.l	rest(sp),~cnt
	bls.s	b8toha_end
	addq.w	#7,~cnt
	andi.w	#$fff8,~cnt
	subq.w	#1,~cnt
b8toha_sp_loop:
	move.b	~ch,(~dst)+
	move.b	~ch,(~dst)+
	move.b	~ch,(~dst)+
	dbra	~cnt,b8toha_sp_loop
b8toha_end:
	move.b	~ch,(~dst)+
	move.l	~dst,d0
	rts
	.end
