*
*	c16toda.s: part of xd(heXadecimal Dump tool)
*	Copyright  1994,95  씎Y(oo), HGG00736@niftyserve.or.jp
*
.ifndef	MPU
MPU	.equ	68000
.endif

	.offset	4
cset	.ds.l	1
dst	.ds.l	1
src	.ds.l	1
rest	.ds.l	1

~cset	.reg	a0
~dst	.reg	a1
~src	.reg	a2
~tmp	.reg	d0
~ch	.reg	d1
~cnt	.reg	d2

	.text
	.even
.if	MPU>=68020
	.quad
.endif
*
* uchar* c16toda(uchar* cset, uchar* dst, ulong* src, int rest)
* in:	cset	convert char set
*	dst	output buffer
*	src	pointer to convert value
*	rest	rest byte count
* out:	pointer to end of string
*
_c16toda::
	movem.l	cset(sp),~cset/~dst/~src
	moveq.l	#15,~cnt
	cmp.l	rest(sp),~cnt
	blo.s	c16toda_loop
	move.l	rest(sp),~cnt
	subq.l	#1,~cnt
c16toda_loop:
	moveq.l	#'+',~tmp
	moveq.l	#0,~ch
	move.b	(~src)+,~ch
	bpl.s	@f
	moveq.l	#'-',~tmp
	neg.b	~ch
@@:
	move.b	~tmp,(~dst)+
	divu.w	#100,~ch
	move.b	(~cset,~ch.w),(~dst)+
	clr.w	~ch
	swap	~ch
	divu.w	#10,~ch
	move.b	(~cset,~ch.w),(~dst)+
	swap	~ch
	move.b	(~cset,~ch.w),(~dst)+
	move.b	#' ',(~dst)+
	dbra	~cnt,c16toda_loop

	moveq.l	#' ',~ch
	moveq.l	#15,~cnt
	sub.l	rest(sp),~cnt
	blo.s	c16toda_end
c16toda_sp_loop:
	move.b	~ch,(~dst)+
	move.b	~ch,(~dst)+
	move.b	~ch,(~dst)+
	move.b	~ch,(~dst)+
	move.b	~ch,(~dst)+
	dbra	~cnt,c16toda_sp_loop
c16toda_end:
	move.b	~ch,(~dst)+
	move.l	~dst,d0
	rts
	.end
