*
*	c16toha.s: part of xd(heXadecimal Dump tool)
*	Copyright  1994,95  씎Y(oo), HGG00736@niftyserve.or.jp
*
.ifndef	MPU
MPU	.equ	68000
.endif

	.offset	4
cset	.ds.l	1
dst	.ds.l	1
src	.ds.l	1
rest	.ds.l	1

~cset	.reg	a0
~dst	.reg	a1
~src	.reg	a2
~tmp	.reg	d0
~ch	.reg	d1
~cnt	.reg	d2

	.text
	.even
.if	MPU>=68020
	.quad
.endif
*
* uchar* c16toha(uchar* cset, uchar* dst, ulong* src, int rest)
* in:	cset	convert char set
*	dst	output buffer
*	src	pointer to convert value
*	rest	rest byte count
* out:	pointer to end of string
*
_c16toha::
	movem.l	cset(sp),~cset/~dst/~src
	moveq.l	#0,~tmp
	moveq.l	#15,~cnt
	cmp.l	rest(sp),~cnt
	blo.s	c16toha_loop
	move.l	rest(sp),~cnt
	subq.l	#1,~cnt
c16toha_loop:
	move.b	(~src)+,~ch
	move.b	~ch,~tmp
	lsr.b	#4,~tmp
	move.b	(~cset,~tmp.w),(~dst)+
	moveq.l	#$f,~tmp
	and.b	~ch,~tmp
	move.b	(~cset,~tmp.w),(~dst)+
	move.b	#' ',(~dst)+
	dbra	~cnt,c16toha_loop

	moveq.l	#' ',~ch
	moveq.l	#15,~cnt
	sub.l	rest(sp),~cnt
	blo.s	c16toha_end
c16toha_sp_loop:
	move.b	~ch,(~dst)+
	move.b	~ch,(~dst)+
	move.b	~ch,(~dst)+
	dbra	~cnt,c16toha_sp_loop
c16toha_end:
	move.b	~ch,(~dst)+
	move.l	~dst,d0
	rts
	.end
