*
*	convda.s: part of xd(heXadecimal Dump tool)
*	Copyright  1994,95  씎Y(oo), HGG00736@niftyserve.or.jp
*
.ifndef	MPU
MPU	.equ	68000
.endif

	.text
	.even
.if	MPU>=68020
	.quad
.endif
b4toda_tab:
	.dc.l 1000000000
	.dc.l 100000000
b4toda_tab2:
	.dc.l 10000000
	.dc.l 1000000
	.dc.l 100000
	.dc.l 10000
	.dc.l 1000
	.dc.l 100
	.dc.l 10
	.dc.l 0

~val	.reg	d0
~tval	.reg	d1
~ch	.reg	d2
~dst	.reg	a1
~tab	.reg	a0
*
* func:	conv4a
*   in:	d0	convert value
*	a1	distination buffer
*  out:	a1	pointer of last char + 1
*  brk:	d0, d1, d2, a0
*
conv4a::
	moveq.l	#'0',~ch
	lea.l	b4toda_tab(pc),~tab
	moveq.l	#9,~tval
	cmp.l	~val,~tval
	bcs.s	b4toda_cmp_loop
	moveq.l	#8,~tval
b4toda_0_loop:
	move.b	~ch,(~dst)+
	dbra	~tval,b4toda_0_loop
	bra.s	b4toda_conv_end

b4toda_cmp_loop:
	cmp.l	(~tab)+,~val
	bhs.s	b4toda_conv_0
	move.b	~ch,(~dst)+
	bra.s	b4toda_cmp_loop

b4toda_2:
	lea.l	b4toda_tab2(pc),~tab
b4toda_conv_0:
	move.l	-4(~tab),~tval
	bra.s	b4toda_set_ch

b4toda_inc_ch:
	addq.b	#1,~ch
b4toda_sub_value:
	sub.l	~tval,~val
	bcc.s	b4toda_inc_ch
	add.l	~tval,~val
	move.b	~ch,(~dst)+
	move.l	(~tab)+,~tval
	beq.s	b4toda_conv_end
b4toda_set_ch:
	moveq.l	#'0',~ch
	bra.s	b4toda_sub_value

b4toda_conv_end:
	add.b	#'0',~val
	move.b	~val,(~dst)+
	rts

.if	MPU>=68020
	.quad
.endif
b8toda_tab:
	.dc.l -1981284352
	.dc.l -1966660860
	.dc.l -1486618624
	.dc.l 232830643
	.dc.l 1569325056
	.dc.l 23283064
	.dc.l 1874919424
	.dc.l 2328306
	.dc.l -1530494976
	.dc.l 232830
	.dc.l 276447232
	.dc.l 23283
	.dc.l 1316134912
	.dc.l 2328
	.dc.l -727379968
	.dc.l 232
	.dc.l 1215752192
	.dc.l 23
	.dc.l 1410065408
	.dc.l 2
	.dc.l 1000000000
	.dc.l 0

*~val	.reg	d0
*~tval	.reg	d1
*~ch	.reg	d2
*~tab	.reg	a0
*~dst	.reg	a1
~valH	.reg	d1
~tvalH	.reg	d3
~tvalL	.reg	a2

*
* func:	conv8a
*   in:	d0	convert value low
*	d1	convert value high
*	a1	distination buffer
*  out:	a1	pointer of last char + 1
*  brk:	d0, d1, d2, a0
*
conv8a::
	tst.l	~valH
	bne.s	b8toda_nz0
*
*	d0(~ch) =ch,  d1(~val)=valL, d2(~valH)=valH
*	a0(~buf)=buf, a1(~ptr)=    , a2(~tab) =
*
b8toda_0:
	moveq.l	#'0',~ch
	moveq.l	#9,~valH
b8toda_0_loop:
	move.b	~ch,(~dst)+
	dbra	~valH,b8toda_0_loop
	bra	conv4a

b8toda_nz0:
*
*	d1(~val) != 0 Ȃ̂Ńe[uōŌ̗vf܂ŐiނƂ͂Ȃ
*
	movem.l	d3/a2,-(sp)
	lea.l	b8toda_tab(pc),~tab
	bra.s	b8toda_nz0_loop

b8toda_nz0_loop0:
	move.b	#'0',(~dst)+
	addq.w	#8,~tab
b8toda_nz0_loop:
	cmp.l	4(~tab),~valH
	blo.s	b8toda_nz0_loop0	* tabH > valH
	bhi.s	b8toda_set_tval		* tabH < valH
	cmp.l	0(~tab),~val
	blo.s	b8toda_nz0_loop0	* tabL > valL
	bra.s	b8toda_set_tval		* tabH < valH

b8toda_inc_ch:
	addq.b	#1,~ch
b8toda_sub_value:
	sub.l	~tvalL,~val
	subx.l	~tvalH,~valH
	bcc.s	b8toda_inc_ch
	add.l	~tvalL,~val
	addx.l	~tvalH,~valH
	move.b	~ch,(~dst)+
	tst.l	~tvalH
	beq	b8toda_conv_end
b8toda_set_tval:
	move.l	(~tab)+,~tvalL
	move.l	(~tab)+,~tvalH
	moveq.l	#'0',~ch
	bra.s	b8toda_sub_value

b8toda_conv_end:
	movem.l	(sp)+,d3/a2
	bra	b4toda_2
	.end
