*
*	l2toha.s: part of xd(heXadecimal Dump tool)
*	Copyright  1994,95  씎Y(oo), HGG00736@niftyserve.or.jp
*
.ifndef	MPU
MPU	.equ	68000
.endif

	.offset	4
cset	.ds.l	1
dst	.ds.l	1
src	.ds.l	1
rest	.ds.l	1

~cset	.reg	a0
~dst	.reg	a1
~src	.reg	a2
~tmp	.reg	d0
~ch	.reg	d1
~cnt	.reg	d2

	.text
	.even
.if	MPU>=68020
	.quad
.endif
*
* uchar* l2toha(uchar* cset, uchar* dst, ulong* src, int rest)
* in:	cset	convert char set
*	dst	output buffer
*	src	pointer to convert value
*	rest	rest of src byte count
* out:	pointer to end of string
*
_l2toha::
	movem.l	cset(sp),~cset/~dst/~src
	moveq.l	#16,~cnt
	cmp.l	rest(sp),~cnt
	bls.s	l2toha
	move.l	rest(sp),~cnt
l2toha:
	lsr.l	#1,~cnt
	beq.s	l2toha_sp
	subq.l	#1,~cnt
	moveq.l	#0,~tmp
l2toha_loop:
	move.b	1(~src),~ch
	move.b	~ch,~tmp
	lsr.b	#4,~tmp
	move.b	(~cset,~tmp.w),(~dst)+
	moveq.l	#$0f,~tmp
	and.b	~ch,~tmp
	move.b	(~cset,~tmp.w),(~dst)+
	move.b	0(~src),~ch
	move.b	~ch,~tmp
	lsr.b	#4,~tmp
	move.b	(~cset,~tmp.w),(~dst)+
	moveq.l	#$0f,~tmp
	and.b	~ch,~tmp
	move.b	(~cset,~tmp.w),(~dst)+
	addq.w	#2,~src
	move.b	#' ',(~dst)+
	move.b	#' ',(~dst)+
	dbra	~cnt,l2toha_loop

l2toha_sp:
	moveq.l	#' ',~ch
	move.l	#16,~cnt
	sub.l	rest(sp),~cnt
	bls.s	l2toha_end
	addq.w	#1,~cnt
	andi.w	#$fffe,~cnt
	subq.w	#1,~cnt
l2toha_sp_loop:
	move.b	~ch,(~dst)+
	move.b	~ch,(~dst)+
	move.b	~ch,(~dst)+
	dbra	~cnt,l2toha_sp_loop
l2toha_end:
	move.b	~ch,(~dst)+
	move.l	~dst,d0
	rts
	.end
