*
*	b4toda.s: part of xd(heXadecimal Dump tool)
*	Copyright  1994,95  씎Y(oo), HGG00736@niftyserve.or.jp
*
.ifndef	MPU
MPU	.equ	68000
.endif
	.xref	conv4a

	.offset	4
cset	.ds.l	1
dst	.ds.l	1
src	.ds.l	1
rest	.ds.l	1

~cset	.reg	a0
~dst	.reg	a1
~src	.reg	a2
~val	.reg	d0
~ch	.reg	d2
~cnt	.reg	d3
~rest	.reg	d4
~saves	.reg	d3/d4
savelen	.equ	8

	.text
	.even
.if	MPU>=68020
	.quad
.endif
*
* uchar* b4toda(uchar* cset, uchar* dst, ulong* src, int rest)
* in:	cset	convert char set
*	dst	output buffer
*	src	pointer to convert value
*	rest	rest of src byte count
* out:	pointer to end of string
*
_b4toda::
	movem.l	cset(sp),~cset/~dst/~src
	movem.l	~saves,-(sp)
	moveq.l	#16,~cnt
	move.l	rest+savelen(sp),~rest
	cmp.l	~rest,~cnt
	bls.s	b4toda_0
	move.l	~rest,~cnt
b4toda_0:
	lsr.l	#2,~cnt
	beq.s	b4toda_sp
	subq.l	#1,~cnt
b4toda_loop:
	moveq.l	#'+',~ch
	move.l	(~src)+,~val
	bpl.s	@f
	moveq.l	#'-',~ch
	neg.l	~val
@@:
	move.b	~ch,(~dst)+
	bsr	conv4a
	move.b	#' ',(~dst)+
	dbra	~cnt,b4toda_loop

b4toda_sp:
	moveq.l	#' ',~ch
	move.l	#16,~cnt
	sub.l	~rest,~cnt
	bls.s	b4toda_end
	addq.w	#3,~cnt
	andi.w	#$fffc,~cnt
	subq.w	#1,~cnt
b4toda_sp_loop:
	move.b	~ch,(~dst)+
	move.b	~ch,(~dst)+
	move.b	~ch,(~dst)+
	dbra	~cnt,b4toda_sp_loop
b4toda_end:
	move.b	~ch,(~dst)+
	movem.l	(sp)+,~saves
	move.l	~dst,d0
	rts
	.end
