*
*	l2toda.s: part of xd(heXadecimal Dump tool)
*	Copyright  1994,95  씎Y(oo), HGG00736@niftyserve.or.jp
*
.ifndef	MPU
MPU	.equ	68000
.endif

	.offset	4
cset	.ds.l	1
dst	.ds.l	1
src	.ds.l	1
rest	.ds.l	1

~cset	.reg	a0
~dst	.reg	a1
~src	.reg	a2
~tmp	.reg	d0
~ch	.reg	d1
~cnt	.reg	d2

	.text
	.even
.if	MPU>=68020
	.quad
.endif
*
* uchar* l2toda(uchar* cset, uchar* dst, ulong* src, int rest)
* in:	cset	convert char set
*	dst	output buffer
*	src	pointer to convert value
*	rest	rest byte count
* out:	pointer to end of string
*
_l2toda::
	movem.l	cset(sp),~cset/~dst/~src
	moveq.l	#16,~cnt
	cmp.l	rest(sp),~cnt
	bls.s	l2toda_0
	move.l	rest(sp),~cnt
l2toda_0:
	lsr.w	#1,~cnt
	beq.s	l2toda_sp
	subq.l	#1,~cnt
l2toda_loop:
	moveq.l	#'+',~tmp
	moveq.l	#0,~ch
	move.w	(~src)+,~ch
	rol.w	#8,~ch
	bpl.s	@f
	moveq.l	#'-',~tmp
	neg.w	~ch
@@:
	move.b	~tmp,(~dst)+
	divu.w	#10000,~ch
	move.b	(~cset,~ch.w),(~dst)+
	clr.w	~ch
	swap	~ch
	divu.w	#1000,~ch
	move.b	(~cset,~ch.w),(~dst)+
	clr.w	~ch
	swap	~ch
	divu.w	#100,~ch
	move.b	(~cset,~ch.w),(~dst)+
	clr.w	~ch
	swap	~ch
	divu.w	#10,~ch
	move.b	(~cset,~ch.w),(~dst)+
	swap	~ch
	move.b	(~cset,~ch.w),(~dst)+
	move.b	#' ',(~dst)+
	dbra	~cnt,l2toda_loop

l2toda_sp:
	moveq.l	#' ',~ch
	moveq.l	#16,~cnt
	sub.l	rest(sp),~cnt
	bls.s	l2toda_end
	subq.l	#1,~cnt
	lsr.w	#1,~cnt
l2toda_sp_loop:
	move.b	~ch,(~dst)+
	move.b	~ch,(~dst)+
	move.b	~ch,(~dst)+
	move.b	~ch,(~dst)+
	move.b	~ch,(~dst)+
	move.b	~ch,(~dst)+
	move.b	~ch,(~dst)+
	dbra	~cnt,l2toda_sp_loop
l2toda_end:
	move.b	~ch,(~dst)+
	move.l	~dst,d0
	rts
	.end
