*
*	l4toua.s: part of xd(heXadecimal Dump tool)
*	Copyright  1994,95  씎Y(oo), HGG00736@niftyserve.or.jp
*
.ifndef	MPU
MPU	.equ	68000
.endif
	.xref	conv4a

	.offset	4
cset	.ds.l	1
dst	.ds.l	1
src	.ds.l	1
rest	.ds.l	1

~cset	.reg	a0
~dst	.reg	a1
~src	.reg	a2
~val	.reg	d0
~ch	.reg	d2
~cnt	.reg	d3
~rest	.reg	d4
~saves	.reg	d0/d3/d4
savelen	.equ	12

	.text
	.even
.if	MPU>=68020
	.quad
.endif
*
* uchar* l4toua(uchar* cset, uchar* dst, ulong* src, int rest)
* in:	cset	convert char set
*	dst	output buffer
*	src	pointer to convert value
*	rest	rest of src byte count
* out:	pointer to end of string
*
_l4toua::
	movem.l	cset(sp),~cset/~dst/~src
	movem.l	~saves,-(sp)
	moveq.l	#16,~cnt
	move.l	rest+savelen(sp),~rest
	cmp.l	~rest,~cnt
	bls.s	l4toua_0
	move.l	~rest,~cnt
l4toua_0:
	lsr.l	#2,~cnt
	beq.s	l4toua_sp
	subq.l	#1,~cnt
l4toua_loop:
	move.b	#' ',(~dst)+
.if	MPU<68020
	move.b	(~src)+,3(sp)
	move.b	(~src)+,2(sp)
	move.b	(~src)+,1(sp)
	move.b	(~src)+,0(sp)
	move.l	(sp),~val
.else
	move.l	(~src)+,~val
	rol.w	#8,~val
	swap	~val
	rol.w	#8,~val
	tst.l	~val
.endif
	bsr	conv4a
	move.b	#' ',(~dst)+
	dbra	~cnt,l4toua_loop

l4toua_sp:
	moveq.l	#' ',~ch
	move.l	#16,~cnt
	sub.l	~rest,~cnt
	bls.s	l4toua_end
	addq.w	#3,~cnt
	andi.w	#$fffc,~cnt
	subq.w	#1,~cnt
l4toua_sp_loop:
	move.b	~ch,(~dst)+
	move.b	~ch,(~dst)+
	move.b	~ch,(~dst)+
	dbra	~cnt,l4toua_sp_loop
l4toua_end:
	move.b	~ch,(~dst)+
	movem.l	(sp)+,~saves
	move.l	~dst,d0
	rts
	.end
